SystemOrganization addCategory: #HarryPotter!

Object subclass: #Escuela
	instanceVariableNames: 'casas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
agregarCasa: unaCasa
casas add: unaCasa.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:03'!
cuantosSiguenA: unMago
casas sum:[:casa | casa cuantosSiguenA: unMago]! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:55'!
inicializar 
casas := Set new.! !

Object subclass: #Gryffindor
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:52'!
aceptaA: unMago
^(unMago inteligencia >80 & unMago inteligencia <120 & unMago colorDePelo = 'rojo').! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:25'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:08'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/4/2014 02:54'!
puedeEntrar: mago
^(mago esPelirrojo) | ((mago inteligencia > 80) & (mago inteligencia < 120))! !

Object subclass: #Hufflepuff
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^true.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:25'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:19'!
puedeEntrar: mago
^true! !

Object subclass: #Mago
	instanceVariableNames: 'colorPelo inteligencia sangreSucia enemigos padre escuela losQueSigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
agregarAQuienSigo: unMago
losQueSigo add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
agregarEnemigo:unMago
enemigos add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo
^colorPelo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo: color
colorPelo := color! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:46'!
esEnemigoDe: unMago
^(enemigos includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:47'!
esHermanoDe: unMago
^( (padre = unMago miPadreEs) & (self ~= unMago) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/4/2014 02:54'!
esPelirrojo
^self colorPelo = 'pelirrojo'! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:57'!
escuela
^escuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
escuela: unaEscuela
escuela:=unaEscuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:31'!
inicializarEnemigos
enemigos := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:12'!
inicializarLosQueSigo
losQueSigo := Set new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:09'!
inteligencia
^inteligencia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:04'!
inteligencia: numero
inteligencia := numero! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:43'!
miPadreEs 
^padre.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
muyInteligente
^(self inteligencia) >= 120! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:58'!
puedoSeguirA: unMago
^(
	(self esEnemigoDe: unMago not) & 
	( 
		(self esHermanoDe: unMago) | 
		( 
			unMago inteligencia > self inteligencia | 
			self escuela cuantosSiguenA: unMago >3
		) 
	) 
).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:22'!
sangreSucia
^sangreSucia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:12'!
sangreSucia: valor
sangreSucia := valor! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:11'!
seguisA: unMago
^(losQueSigo includes: unMago).! !

Object subclass: #Ravenclaw
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^(unMago inteligencia >120).! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:26'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
puedeEntrar: mago
^mago muyInteligente! !

Object subclass: #Slytherin
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:00'!
aceptaA: unMago
^(unMago tieneSangreSucia ).! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:27'!
agregarMago: unMago
(self aceptaA: unMago) ifTrue:[magos add: unMago].! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:14'!
cuantosSiguenA: unMago
^(magos collect:[:mago | mago seguisA: unMago]) size.! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 00:23'!
inicializar
magos := Set new.! !

!Slytherin methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:20'!
puedeEntrar: mago
^(mago sangreSucia) not! !

Object subclass: #Sombrero
	instanceVariableNames: 'casas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sombrero methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 11:15'!
agregarCasas: casa! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 11:10'!
crearCasas
casas := OrderedCollection new.! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 11:11'!
seleccionarCasa: mago 
^casas detect: [ :casa | casa puedeEntrar: mago ]! !
